if(isObject(MirrorsGUI))
	MirrorsGUI.delete();
new GuiControl(MirrorsGUI)
{
	new GuiWindowCtrl(MirrorsUI)
	{
		position = "200 200";
		extent = "400 175";
		text = "Mirrors Control";
		
		accelerator = "Escape";
		command = "Canvas.popDialog(MirrorsGUI);";
		closeCommand = "Canvas.popDialog(MirrorsGUI);";
		
		new GuiTextCtrl(MirrorsText)
		{
			position = "30 155";
			text = "Mirror: 0 0 0   L0 STABLE";
			
			controls = "N/A";
		};
	};
};

function AddMirrorsGroup(%pos, %num, %col)
{
	(%mainBtn = new GuiBitmapButtonCtrl()
	{
		position = getWords(vectorSub(%pos, "25 25"), 0, 1);
		extent = "50 50";
		controls = %num;
		text = "";
		
		bitmap = "Add-Ons/Client_Mirrors/Medium Circle";
		command = "Mirrors_Click($ThisControl);";
	}).setColor(%col);
	MirrorsUI.add(%mainBtn);
	%const = 1.25664;
	for(%i=0;%i<5;%i++)
	{
		%ang = %const * %i;
		%x = mFloatLength(mSin(%ang) * 50 + getWord(%pos, 0) - 12.5, 0);
		%y = mFloatLength(-mCos(%ang) * 50 + getWord(%pos, 1) - 12.5, 0);
		(%btn = new GuiBitmapButtonCtrl()
		{
			position = %x SPC %y;
			extent = "25 25";
			group = %num;
			text = "";
			bit = %i;
			
			bitmap = "Add-Ons/Client_Mirrors/Medium Circle";
			command = "Mirrors_Click($ThisControl);";
		}).setColor("0 0 0 1");
		MirrorsUI.add(%btn);
	}
}

AddMirrorsGroup("75 90", 0, "1 0 0 1");
AddMirrorsGroup("200 90", 1, "1 1 0 1");
AddMirrorsGroup("325 90", 2, "0 0 1 1");

function Mirrors_GroupCount(%num)
{
	%count = MirrorsUI.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%obj = MirrorsUI.getObject(%i);
		if(%obj.group != %num) continue;
		if(%obj.toggled) %btnsOn++;
	}
	return %btnsOn + 0;
}

function Mirrors_Click(%this)
{
	if(%this.controls !$= "")
	{
		%count = MirrorsUI.getCount();
		for(%i=0;%i<%count;%i++)
		{
			%obj = MirrorsUI.getObject(%i);
			if(%obj.group != %this.controls) continue;
			if(%obj.toggled) %btnsOn++;
		}
		for(%i=0;%i<%count;%i++)
		{
			%obj = MirrorsUI.getObject(%i);
			if(%obj.group != %this.controls) continue;
			%obj.toggled = %btnsOn < 3;
		}
	}
	else %this.toggled = !%this.toggled;
	Mirrors_Update();
}

function Mirrors_Update()
{
	%count = MirrorsUI.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%obj = MirrorsUI.getObject(%i);
		if(%obj.controls !$= "") continue;
		%obj.setColor(%obj.toggled ? "1 1 1 1" : "0 0 0 1");
		if(%obj.toggled) %bit[%obj.group] += mPow(2, %obj.bit);
	}
	for(%i=0;%i<3;%i++)
		%val[%i] = Mirrors_BitsToFive(%bit[%i]);
	%sum = %val0 + %val1 + %val2;
	if(%val0 == 0 || (%val1 + %val2) == 0) %mainStable = 1;
	if(%sum != 0 && %sum != 93)
	{
		if(!%mainStable)
		{
			%unstable0 = 1;
			%count0 = Mirrors_GroupCount(0);
			%count1 = Mirrors_GroupCount(1);
			%count2 = Mirrors_GroupCount(2);
			if(%count0 == 3 || %count1 == 3 || %count2 == 3)
			{
				%countOf17 = (%val0 == 17) + (%val1 == 17) + (%val2 == 17);
				if(%countOf17 >= 1) %unstable1 = getMax(%unstable1, 4 - (%countOf17 == 1));
				%countOf19 = (%val0 == 19) + (%val1 == 19) + (%val2 == 19);
				if(%countOf19 == 1) %unstable1 = getMax(%unstable1, 4);
				else if(%countOf19 == 2) %unstable1 = getMax(%unstable1, 5);
				else if(%countOf19 == 3) %unstable1 = getMax(%unstable1, 6);
				%countOf20 = (%val0 == 20) + (%val1 == 20) + (%val2 == 20);
				if(%countOf20 >= 1) %unstable1 = getMax(%unstable1, 4 - (%countOf20 == 1));
				%countOf23 = (%val0 == 23) + (%val1 == 23) + (%val2 == 23);
				if(%countOf23 >= 2) %unstable1 = getMax(%unstable1, 6 - (%countOf23 == 2));
				%countOf24 = (%val0 == 24) + (%val1 == 24) + (%val2 == 24);
				if(%countOf24 >= 2) %unstable1 = getMax(%unstable1, 6 - (%countOf24 == 2));
				if(%countOf17 + %countOf19 + %countOf20 + %countOf23 + %countOf24 == 3)
				{
					%pattern = " "@%val0 SPC %val1 SPC %val2@" ";
					%listCW = " 19 23 17 20 24 19 23 ";
					%listCCW = " 19 24 20 17 23 19 24 ";
					if(strPos(%listCW, %pattern) != -1 || strPos(%listCCW, %pattern) != -1) %unstable1 = 6;
					%unstableAdd++;
				}
				if(%unstable1 $= "")
				{
					%consecList = "16 18 21 22 25";
					for(%i=0;%i<5;%i++)
					{
						%consec = getWord(%consecList, %i);
						if(%val0 == %consec) { %consecAmt++; %consecVal[%consec]++; %consecMax = getMax(%consecMax, %consecVal[%consec]); }
						if(%val1 == %consec) { %consecAmt++; %consecVal[%consec]++; %consecMax = getMax(%consecMax, %consecVal[%consec]); }
						if(%val2 == %consec) { %consecAmt++; %consecVal[%consec]++; %consecMax = getMax(%consecMax, %consecVal[%consec]); }
					}
					if(%consecAmt == 3 && %consecMax == 3) %unstable1 = 6;
					else if(%consecAmt == 3 || %consecMax == 2) %unstableAdd += 2;
					else if(%consecAmt) %unstableAdd++;
				}
			}
			else if(%count0 == 2 || %count1 == 2 || %count2 == 2)
			{
				if(%val0 == %val1 && %val1 == %val2) %unstable1 = 4;
				else if(%val0 != %val1 && %val1 != %val2 && %val0 != %val2) %unstable1 = 2;
				else
				{
					if(%val0 == %val1 && (%count0 + %count1) == 4) %unstable1 = 3;
					else if(%val0 == %val2 && (%count0 + %count2) == 4) %unstable1 = 3;
					else if(%val1 == %val2 && (%count1 + %count2) == 4) %unstable1 = 3;
					else %unstable1 = 2;
				}
			}
			else
			{
				if(%val0 > %val2) %unstable1 = 2;
				if(%val0 != 0 && %val1 != 0 && %val2 != 0) %unstable1 = 2;
				if(%val0 + %val1 + %val2 >= 31) %unstableAdd++;
				if((%val0 + %val1 >= 31) && (%val0 + %val2 >= 31) && (%val1 + %val2 >= 31)) %unstable1 = 6;
			}
		}
	}
	for(%i=0;%i<2;%i++) %unstable = getMax(%unstable, %unstable[%i]);
	%unstable += %unstableAdd; %unstable = getMin(%unstable, 6);
	MirrorsText.setText("Mirror "@%val0 SPC %val1 SPC %val2@"   "@(!%unstable ? "L0 STABLE" : "L"@%unstable@" UNSTABLE"));
}

function Mirrors_FiveToBits(%val)
{
	%bits = "0 1 16 8 4 2 17 9 5 3 24 20 18 12 10 6 25 21 19 13 11 7 28 26 22 14 29 27 23 15 30 31";
	return getWord(%bits, %val);
}

function Mirrors_BitsToFive(%val)
{
	%five = "0 1 5 9 4 8 15 21 3 7 14 20 13 19 25 29 2 6 12 18 11 17 24 28 10 16 23 27 22 26 30 31";
	return getWord(%five, %val);
}

function openMirrorsGUI(%tog)
{ if(%tog) Canvas.pushDialog(MirrorsGUI); }

if(!$MirrorsHasBound)
{
	$MirrorsHasBound = 1;
	$remapDivision[$remapCount] = "Mirrors Client";
	$remapName[$remapCount] = "Mirrors GUI";
	$remapCmd[$remapCount] = "openMirrorsGUI";
	$remapCount++;
}